const Base = require('./base.js');
const operation = require('../public/operation');
const moment = require('moment');

//收费

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  //待检车辆列表，1,3内外地
  async waitingListAction(){
      let guid = await operation.getGUID();
      let local = await operation.getList(guid,1);
      let no_local = await operation.getList(guid,3);
      let list = [];
      let list_no = [];
      local.forEach(function (item,index) {
          list.push({
              "license":item.substr(0,item.indexOf(".")),
              "type":item.substr(item.indexOf(".")+1,2),
              "time":item.substr(item.length-11,11),
              // "index":index,
          })
      });
      no_local.forEach(function (item,index) {
          list_no.push({
              "license":item.substr(0,item.indexOf(".")),
              "type":item.substr(item.indexOf(".")+1,2),
              "time":item.substr(item.length-11,11),
              // "index":index,
          })
      });
      this.json({
          "local":list,
          "no_local":list_no
      })
  };
  //获取车辆详细信息
  async getDetailAction(){
      let data = this.post();
      var guid = await operation.getGUID();
      var back = await operation.getDetail(guid,data.license,data.type,(data.license.substr(0,1)==='沪' ? 1 : 3));
      this.json(back)
      // this.json({
      //     '车牌': '沪G59371',
      //     '初次登记': '2007-11-28',
      //     '有效期止': '2007-10-18',
      //     '车辆类型': 'K33',
      //     '车辆识别代号': 'LSGJT52U28H008322',
      //     '检验情况': '正在检验： [检验通过/照片不足]',
      //     '车辆品牌': '别克(BUICK)',
      //     '所有人': '董大洪',
      //     '行政区划': '310117',
      //     '车辆型号': 'SGM7161LE AT'
      // })
  };
  //违章车辆信息补充
  async violationMsgAction(){
      let data = this.post();
      let guid = await operation.getGUID();
      let list = await operation.getList(guid,(data.license.substr(0,1)==='沪' ? 1 : 3));
      var type = "";
      list.forEach(function (item) {
          if(item.substr(0,item.indexOf("."))===data.license){
              type = item.substr(item.indexOf(".")+1,2)
          }
      });
      let back = await operation.getDetail(guid,data.license,type,(data.license.substr(0,1)==='沪' ? 1 : 3));
      this.json(back)
  }
  async testAction(){
      this.json({
          '车牌': '沪G59371',
          '初次登记': '2007-11-28',
          '有效期止': '2007-10-18',
          '车辆类型': 'K33',
          '车辆识别代号': 'LSGJT52U28H008322',
          '检验情况': '正在检验： [检验通过/照片不足]',
          '车辆品牌': '别克(BUICK)',
          '所有人': '董大洪',
          '行政区划': '310117',
          '车辆型号': 'SGM7161LE AT'
      })
      // this.json({
      //     "code":0,"msg":"","count":24,
      //     "data":[
      //         {'license':'苏J820R2','type':'02','time':'10-23 10:13'},
      //         {'license':'苏AD85B0','type':'02','time':'10-23 09:57'},
      //         {'license':'粤B650DM','type':'02','time':'10-23 09:57'},
      //         {'license':'皖ARQ750','type':'02','time':'10-23 09:48'},
      //         {'license':'皖BK7823','type':'02','time':'10-23 09:29'},
      //         {'license':'浙A369WG','type':'02','time':'10-23 08:32'},
      //         {'license':'皖BLT759','type':'02','time':'10-21 11:04'},
      //         {'license':'皖P8U788','type':'02','time':'10-21 09:42'},
      //         {'license':'赣AWY076','type':'02','time':'10-14 12:40'},
      //         {'license':'苏A2TJ75','type':'02','time':'10-12 09:31'},
      //         {'license':'赣A8M037','type':'02','time':'10-08 10:28'},
      //         {'license':'京EX4518','type':'02','time':'09-29 12:46'},
      //         {'license':'苏CQ3D78','type':'02','time':'09-26 10:02'},
      //         {'license':'藏O0135','type':'23','time':'09-23 11:49'},
      //         {'license':'浙BK607L','type':'02','time':'09-19 11:18'},
      //         {'license':'黑AHJ018','type':'02','time':'08-23 10:40'},
      //         {'license':'粤MPM741','type':'02','time':'08-08 11:30'},
      //         {'license':'皖NA589J','type':'02','time':'07-17 11:05'},
      //         {'license':'赣E35567','type':'02','time':'07-12 11:57'},
      //         {'license':'皖LC7952','type':'02','time':'07-03 13:07'},
      //         {'license':'豫NC0G69','type':'02','time':'06-15 12:16'},
      //         {'license':'苏DT937V','type':'02','time':'06-14 13:59'},
      //         {'license':'鲁C336Q6','type':'02','time':'06-10 10:58'},
      //         {'license':'苏ATA823','type':'02','time':'04-03 13:28'}
      //     ]
      // })
  };
  //收费记录保存
  async saveChargeAction(){
      let data = this.post();
      let name = await this.model('user').where({"accessToken":data.access_token}).find();
      let verify = await this.model('charge').where({"license":data.license}).order('id DESC').limit(50).find();
      if (think.isEmpty(name)){
          //token查询失败
          this.json({
              "code":1,
              "msg":"请重新登录后操作"
          })
      } else if(!think.isEmpty(verify)){
          //50条内重复提交
          this.json({
              "code":1,
              "msg":"在最近50次收费中，您已提交过该车牌收费记录，请勿重复提交！"
          });
      }else {
          data['year'] = moment().year().toString();
          data['month'] = moment().month() + 1;
          data['day'] = moment().format('DD');
          data.date = moment().format('YYYY-MM-DD HH:mm:ss');
          data['operator'] = name.name;
          if (data.customer === ""){
              data.on_account = 0;//挂账用户没传时，给挂账金额强制赋0
          }
          if (typeof data.VIN ==="undefined"||data.VIN === ""){
              data["violation"] = 1//违章或者信息不全
          }
          let back = await this.model('charge').add(data);
          this.json({
              "code":0,
              "msg":""
          })
      }
  }
  //收费记录查询
  async selectChargeAction(){
      var data = this.post();
      //第一次进来不带搜索  搜索当天
      let where = {
          "year":moment().year(),
          "month":moment().month() + 1,
          "day":moment().format('DD')
      };
      if(data.hasOwnProperty("license") && data.hasOwnProperty('date')){
          where['license'] = ['like','%' + data.license + '%'];
          where['year'] = data.date===""? ['like','%%'] : data.date.split('-')[0];
          where['month'] = data.date===""? ['like','%%'] : data.date.split('-')[1];
          where['day'] = data.date===""? ['like','%%'] : data.date.split('-')[2]
      }
      let back = await this.model('charge').where(where).page(data.page,data.limit).countSelect();
      this.json({
          "code": 0
          ,"msg": ""
          ,"count": back.count
          ,"data": back.data
      });
  };
  //设置收费标准 列表
  async setSelectAction(){
      let data = this.post();
      let where = {"project":['like','%' + data.project + '%']};
      let back = await this.model('chargingStandard').where(where).page(data.page,data.limit).countSelect();
      this.json({
          "code": 0
          ,"msg": ""
          ,"count": back.count,
          "data": back.data
      })
  }
  //添加新的收费标准
  async setAddChargeAction(){
      let data = this.post();
      let back = this.model('chargingStandard').add(data);
      this.json({
          'code':0,
          'msg':back
      })
  }
  //修改收费标准
  async setUpdateChargeAction(){
      let data = this.post();
      let doc = {
          "project":data.project,
          "carType":data.carType,
          "cost":data.cost
      };
      let back = await this.model('chargingStandard').where({"id":data.id}).update(doc);
      this.json({
          "code":0,
          "msg":"修改成功"
      })
  }
  //删除收费标准项目
  async setDelChargeAction(){
      let id = this.post().id;
      let back = this.model('chargingStandard').where({"id":id}).delete();
      this.json({
          'code':0,
          'msg':back
      })
  }
  //检测日报统计
  async chargeDayAction(){
      let data = this.post();
      //第一次进来不带搜索  搜索当天
      let where = {
          "year":moment().year(),
          "month":moment().month() + 1,
          "day":moment().format('DD')
      };
      if(data.hasOwnProperty("EP_type") && data.hasOwnProperty('car_type') && data.hasOwnProperty('date')
          && data.hasOwnProperty('customer')){
          where['EP_type'] = ['like','%' + data.EP_type + '%'];
          where['car_type'] = ['like','%' + data.car_type + '%'];
          where['customer'] = ['like','%' + data.customer + '%'];
          // where['year'] = data.date===""? moment().year() : data.date.split('-')[0];
          // where['month'] = data.date===""? moment().month() + 1 : data.date.split('-')[1];
          // where['day'] = data.date===""? moment().format('DD') : data.date.split('-')[2]
          //当查询时不选择日期，会默认当前时间，故弃用
          where['year'] = data.date===""? ['like','%%'] : data.date.split('-')[0];
          where['month'] = data.date===""? ['like','%%'] : data.date.split('-')[1];
          where['day'] = data.date===""? ['like','%%'] : data.date.split('-')[2]
      }
      let back = await this.model('charge').where(where).select();
      this.json({
          "code": 0
          ,"msg": ""
          ,"data": back
      })
  }
  //检测月报统计
  async chargeMonthAction(){
      let data = this.post();
      //首次进来默认赋值时间
      let where = {
          "year":moment().year(),
          "month":moment().month() + 1
      };
      if (data.license == 1){
          where["license"] = ['like','%' + "沪" + '%'];//沪牌
      }else if (data.license ==2){
          where["license"] = ['NOTLIKE','%' + "沪" + '%'];//非沪牌
      }
      if(data.hasOwnProperty("EP_type") && data.hasOwnProperty('car_type') && data.hasOwnProperty('date')
          && data.hasOwnProperty('customer')&& data.hasOwnProperty('contracted')&& data.hasOwnProperty('license')){
          where['EP_type'] = ['like','%' + data.EP_type + '%'];//环检
          where['car_type'] = ['like','%' + data.car_type + '%'];//安检
          where['customer'] = ['like','%' + data.customer + '%'];//挂账
          where['contracted_customer'] = ['like','%' + data.contracted + '%'];//签约
          // where['year'] = data.date===""? moment().year() : data.date.split('-')[0];
          // where['month'] = data.date===""? moment().month() + 1 : data.date.split('-')[1];
          //查询未选择时间，默认所有时间↓（当前时间↑）
          where['year'] = data.date===""? ['like','%%'] : data.date.split('-')[0];
          where['month'] = data.date===""? ['like','%%'] : data.date.split('-')[1];
      }
      //用于循环统计
      let sum = await this.model('charge').where(where).select();
      let ali_pay_sum = 0,//支付宝总计
          on_account_sum = 0,//挂账总计
          EP_sum = 0,//环检应收总计
          Safe_sum = 0,//安检应收总计
          rece_sum = 0,//应收总计
          cost_sum = 0;//实收总计
      sum.forEach(function (item) {
          ali_pay_sum += item.ali_pay;
          on_account_sum += item.on_account;
          EP_sum += item.EP_receivable;
          Safe_sum += item.Safe_receivable;
          rece_sum += item.receivable;
          cost_sum += item.cost;
      });
      //分页展示数据
      let back = await this.model('charge').where(where).page(data.page,data.limit).countSelect();
      this.json({
          "code": 0
          ,"msg": "查询成功！"
          ,"count":back.count
          ,"data": back.data
          ,"sum": {
              "ali_pay_sum":ali_pay_sum,
              "on_account_sum":on_account_sum,
              "EP_sum":EP_sum,
              "Safe_sum":Safe_sum,
              "rece_sum":rece_sum,
              "cost_sum":cost_sum,
          }
      })
  }
  //检测年报统计
  async chargeYearAction(){
      let data = this.post();
      let where = {
          "year":moment().year(),
      };
      if(data.hasOwnProperty("EP_type") && data.hasOwnProperty('car_type') && data.hasOwnProperty('date')
          && data.hasOwnProperty('customer')){
          where['EP_type'] = ['like','%' + data.EP_type + '%'];
          where['car_type'] = ['like','%' + data.car_type + '%'];
          where['customer'] = ['like','%' + data.customer + '%'];
          // where['year'] = data.date===""? moment().year() : data.date;
          //查询未选择时间，默认所有时间↓（当前时间↑）
          where['year'] = data.date===""? ['like','%%'] : data.date;
      }
      //用于循环统计
      let sum = await this.model('charge').where(where).select();
      let ali_pay_sum = 0,//支付宝总计
          on_account_sum = 0,//挂账总计
          EP_sum = 0,//环检应收总计
          Safe_sum = 0,//安检应收总计
          rece_sum = 0,//应收总计
          cost_sum = 0;//实收总计
      sum.forEach(function (item) {
          ali_pay_sum += item.ali_pay;
          on_account_sum += item.on_account;
          EP_sum += item.EP_receivable;
          Safe_sum += item.Safe_receivable;
          rece_sum += item.receivable;
          cost_sum += item.cost;
      });
      //分页展示数据
      let back = await this.model('charge').where(where).page(data.page,data.limit).countSelect();
      this.json({
          "code": 0
          ,"msg": ""
          ,"count":back.count
          ,"data": back.data
          ,"sum": {
              "ali_pay_sum":ali_pay_sum,
              "on_account_sum":on_account_sum,
              "EP_sum":EP_sum,
              "Safe_sum":Safe_sum,
              "rece_sum":rece_sum,
              "cost_sum":cost_sum,
          }
      })
  }
  //删单退款处理
  async chargeDelAction(){
      //1获取操作人
      //2验证退款金额
      //3修改数据
      let data = this.post();
      let operator = await this.model('user').where({"accessToken":data.access_token}).find();
      if (think.isEmpty(operator)) {
          //token查询失败
          this.json({
              "code":1,
              "msg":"请重新登录后操作"
          })
      }else {
          let charge = await this.model('charge').where({"id":data.id}).find()
          if(think.isEmpty(charge) || charge.EP_receivable < data.EP_receivable
              || charge.Safe_receivable < data.Safe_receivable || charge.cost < data.cost){
              //应收大于退款金额
              this.json({
                  "code":1,
                  "msg":"退款金额大于实收金额，退款失败！"
              })
          }else {
              let update = {
                  "EP_receivable": charge.EP_receivable - data.EP_receivable,//环检减去
                  "Safe_receivable": charge.Safe_receivable - data.Safe_receivable,//安检减去
                  "receivable":charge.receivable - data.receivable,//应收减去
                  "cost":charge.cost - data.cost,//实收减去
                  "del_time":moment().format('YYYY-MM-DD HH:mm:ss'),//撤单时间
                  "del_operator":operator.name,//撤单操作人员
                  "remarks":data.remarks//撤单操作人员
              }
              let back = await this.model('charge').where({"id":data.id}).update(update);
              this.json({
                  "code":0,
                  "msg":"操作成功！"
              })
          }
      }
  }
  //违章信息补全列表
  async violationListAction(){
      let data = this.post();
      let where = {
          "violation":1
      };
      if (typeof data.license === "undefined"){
          where["year"] = (data.date===""||typeof data.date==="undefined")? moment().year() : data.date.split('-')[0];
          where["month"] = (data.date===""||typeof data.date==="undefined")? moment().month() + 1 : data.date.split('-')[1];
      } else {
          where["license"] = ['like', '%'+ data.license +'%'];
      }

      let back = await this.model('charge').where(where).page(data.page,data.limit).countSelect();
      this.json({
          "code": 0
          ,"msg": ""
          ,"count":back.count
          ,"data": back.data
      })
  }
  //违章车辆信息更新
  async violationUpdateAction(){
      let data = this.post();
      let update = {
          "VIN":data.VIN,
          "owner":data.owner,
          "violation":0,
      };
      let back = await this.model('charge').where({"id":data.id}).update(update);
      this.json({
          "code":0,
          "msg":""
      })
  }
    //已付费车辆信息更新
    async chargeUpdateAction(){
        let data = this.post();
        let update = {
            'license':data.license,
            'VIN':data.VIN,
            'owner':data.owner,
            'EP_type':data.EP_type,
            'customer':data.customer,
            'carType':data.carType,
            'Safe_receivable':data.Safe_receivable,
            'EP_receivable':data.EP_receivable,
            'receivable':data.receivable,
            'telephone':data.telephone,
            'ali_pay':data.ali_pay,
            'on_account':data.on_account,
            'contracted_customer':data.contracted_customer,
            'remarks':data.remarks,
            'cost':data.cost,
        }
        let name = await this.model('user').where({"accessToken":data.access_token}).find();
        if (think.isEmpty(name)){
            //token查询失败
            this.json({
                "code":1,
                "msg":"请重新登录后操作"
            })
        }else {
            update["up_operator"] = name.name;//修改人名字
            let back = await this.model('charge').where({"id":data.id}).update(update);
            this.json({
                "code":0,
                "msg":"修改成功"
            })
        }

    }
    //月报excel导出
    async monthExcelAction(){
        let data = this.post();
        let where = {};
        if (data.license == 1){
            where["license"] = ['like','%' + "沪" + '%'];//沪牌
        }else if (data.license ==2){
            where["license"] = ['NOTLIKE','%' + "沪" + '%'];//非沪牌
        }
        if(data.hasOwnProperty("EP_type") && data.hasOwnProperty('car_type') && data.hasOwnProperty('date')
            && data.hasOwnProperty('customer')&& data.hasOwnProperty('contracted')){
            where['EP_type'] = ['like','%' + data.EP_type + '%'];//环保
            where['car_type'] = ['like','%' + data.car_type + '%'];//安检
            where['customer'] = ['like','%' + data.customer + '%'];//挂账
            where['contracted_customer'] = ['like','%' + data.contracted + '%'];//签约
            // where['year'] = data.date===""? moment().year() : data.date.split('-')[0];
            // where['month'] = data.date===""? moment().month() + 1 : data.date.split('-')[1];
            where['year'] = data.date===""? ['like','%%'] : data.date.split('-')[0];
            where['month'] = data.date===""? ['like','%%'] : data.date.split('-')[1];
        }
        let field = 'license,EP_type,car_type,customer,contracted_customer,ali_pay,on_account,EP_receivable,Safe_receivable,receivable,cost,telephone,remarks'
        let back = await this.model('charge').where(where).field(field).select();
        console.log(where)
        console.log(back)
        this.json({
            "code":0,
            "msg":"修改成功",
            "data":back,
            "filename":data.date===""? "所有数据统计.xlsx":data.date + "月度统计.xlsx"
        })
    }
    //收费记录查询
    async selectCharge2Action(){
        var data = this.post();
        console.log(data)
        //第一次进来不带搜索  搜索当天
        let where = {
            "year":moment().year(),
            "month":moment().month() + 1,
            "day":moment().format('DD')
        };
        if(data.hasOwnProperty("license") && data.hasOwnProperty('date')){
            where['license'] = ['like','%' + data.license + '%'];
            where['year'] = data.date===""? ['like','%%'] : data.date.split('-')[0];
            where['month'] = data.date===""? ['like','%%'] : data.date.split('-')[1];
            where['day'] = data.date===""? ['like','%%'] : data.date.split('-')[2]
        }
        let back = await this.model('charge').where(where).countSelect();
        this.json({
            "code": 0
            ,"msg": ""
            ,"count": back.count
            ,"data": back.data
        });
    };
};

