const Base = require('./base.js');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
    //下拉列表专用
    async getContractedAction(){
        let back = await this.model('contracted_customer').field('name').order('id ASC').select();
        const dataString = JSON.stringify(back);
        const obj = JSON.parse(dataString);
        const data = obj.unshift({"name":"请选择签约客户"});
        this.json(obj)
    }
    //获取签约客户列表
    async getListAction(){
        let data = this.post()
        let where = {};
        if(data.hasOwnProperty("name")){
            where['name'] = ['like','%' + data.name + '%']
        }
        let back = await this.model('contracted_customer').where(where).page(data.page,data.limit).countSelect()
        this.json({
            "code": 0
            ,"msg": ""
            ,"count": back.count,
            "data": back.data
        })
    }
    //添加签约客户
    async addContractedAction(){
        let data = this.post();
        let back = this.model('contracted_customer').add(data);
        this.json({
            'code':0,
            'msg':back
        })
    };
    //删除签约客户
    async delContractedAction(){
        let id = this.post().id;
        let back = this.model('contracted_customer').where({"id":id}).delete();
        this.json({
            'code':0,
            'msg':back
        })
    };
    //更新签约客户
    async updateContractedAction() {
        let data = this.post();
        console.log(data)
        let doc = {
            "name": data.name,
            "phone": data.phone,
            "remarks": data.remarks,
            "sortNum": data.sortNum,
        };
        let back = await this.model('contracted_customer').where({"id": data.id}).update(doc);
        this.json({
            "code": 0,
            "msg": "修改成功"
        })
    }
};
