const Base = require('./base.js');

module.exports = class extends Base {
  indexAction() {
    return this.display();
  }
  //登录
  async loginAction(){
      if (this.isPost){
          var object = this.post(); ///获取到提交上来的所有数据
          let back = await this.model('user').where({username:object.username}).find();
          if (back.password !== object.password){
            //密码错误
          }else if (back.accessToken == ""){//此处应该验证token

          }else {
            //登录成功
              this.json({
                  "code": 0,
                  "msg": "登录成功！",
                  "data":{
                    "access_token":back.accessToken
                  }
              })
          }
      }
  };
  //获取token
  async tokenAction(){
    var token = this.post();
    let back = await this.model('user').where({accessToken:token.access_token}).find();
    // console.log(back)
      this.json({
          "code": 0,
          "msg": "",
          "data": {
              "username": back.name,
              "sex": "男",
              "role": 1
          }
      })
  }
  //获取左侧菜单树
  async menuAction(){
      var token = this.get().access_token;
      // let back = await this.model('menu').field('menu.*').join([
      //     'role ON menu.id = role.menuId','`user` ON `user`.username = role.username'
      // ]).where({accessToken:token}).select()
      let back = await this.model('role').field('menu.*').join({
          menu:{on:['menuId','id']},
          user:{on:['username','username']}
      }).where({"user.accessToken":token}).select()
      // let back = await this.model('menu').query(`SELECT * FROM menu WHERE id in (SELECT menuId FROM role WHERE username in (SELECT username FROM \`user\` WHERE accessToken = '${token}'))`)
      let data = [];
      back.forEach(function (item) {
          if (item.levelCode == '0'){//父集
              data.push({
                  "title":item.title,
                  "groupCode":item.groupCode,
                  "name":item.name,
                  "list":[]
              })
          }
      });
      data.forEach(function (itemData) {
          back.forEach(function (itemBack) {
              if ( (itemData.groupCode === itemBack.groupCode) && itemBack.levelCode === '1'){//一级子集
                  itemData.list.push({
                      "name":itemBack.name,
                      "title":itemBack.title,
                      "jump":itemBack.jump
                  })
              }
          })
      });
      this.json({
          "code": 0,
          "msg": "",
          "data": data
      })
  }
  //获取角色列表
  async getUserAction(){
      const data = this.get();
      let back
      if (!data.hasOwnProperty("position") || data.position === "全部角色") {
          back = await this.model('user').fieldReverse('password').order('id').page(data.page,data.limit).countSelect();
      }else {
          back = await this.model('user').fieldReverse('password').where({"position":data.position}).order('id').page(data.page,data.limit).countSelect();
      }
      this.json({
          "code": 0,
          "msg": "",
          "count":back.count,
          "data": back.data
      })
  }
  //获取角色下拉框
  async getPositionAction(){
        let back = await this.model('user').field('position').distinct('position').select();
        const dataString = JSON.stringify(back);
        const obj = JSON.parse(dataString);
        const data = obj.unshift({"position":"全部角色"});
        this.json(obj)
    }
  //获取权限树
  async getRoleTreeAction(){
      let back = await this.model('menu').order("id").select()
      const dataString = JSON.stringify(back);
      const obj = JSON.parse(dataString);
      let data = [];
      obj.forEach(function (item) {
          if (item.levelCode == '0'){//父集
              data.push({
                  "title":item.title,
                  "id":item.id,
                  "groupCode":item.groupCode,
                  "field":item.id,
                  "children":[]
              })
          }
      });
      data.forEach(function (itemData) {
          obj.forEach(function (itemObj) {
              if (itemData.groupCode === itemObj.groupCode && itemObj.levelCode === "1"){
                  itemData.children.push({
                      "title":itemObj.title,
                      "id":itemObj.id,
                      // "href":itemObj.url,
                      "field":itemObj.id,
                  })
              }
          })
      })
      this.json(data)
  }
  //删除角色
  async delUserAction(){
      let data = this.post();
      let delUser = await this.model('user').where({"id":data.id}).delete();
      let delRole = await this.model('role').where({"username":['IN',data.username]}).delete();
      this.json({
          "code":0,
          "msg":"删除成功"
      })
  }
  //添加角色
  async addUserAction(){
      let obj = this.post();
      let roleData = [];
      for (var key in obj){
          if(obj.hasOwnProperty(key)){
              if (key === obj[key] && !isNaN(key)){
                  roleData.push({
                      "username":obj.username,
                      "menuId":key
                  })
              }
          }
      }
      let data = {
          "username":obj.username,
          "password":"e10adc3949ba59abbe56e057f20f883e",//默认"123456" md5加密
          "name":obj.name,
          "position":obj.position,
          "accessToken":"",
      };
      let back = null
      back = await this.model('user').add(data).catch(async err =>{
          if (think.isError(err)){
              this.json({"code":1,"msg":"用户名重名！"})
          }
      })
      if (back !== null) {
          let roleBack = await this.model('role').addMany(roleData)
      }
  }
  //编辑角色
  async updateUserAction(){
      //更新user表
      let data = this.post();
      let userData = {
          "name":data.name,
          "position":data.position
      };
      let userBack = await this.model('user').where({"username":data.username}).update(userData);

      let roleData = [];
      for (var key in data){
          if(data.hasOwnProperty(key)){
              if (key === data[key] && !isNaN(key)){
                  roleData.push({
                      "username":data.username,
                      "menuId":key
                  })
              }
          }
      }
      //权限没传则不修改role表
      if (roleData.length > 0){
          //删除role表内所有username对应数据
          let delRole = null;
          delRole= await this.model('role').where({"username":data.username}).delete()
          if (delRole !== null) {
              //插入新权限
              let addRole = await this.model('role').addMany(roleData)
          }
      }
      this.json({
          "code":0,
          "msg":"修改成功"
      })
  }
  //重置或修改密码
  async pwAction(){
      let data = this.post();
      let old = await this.model('user').where({"accessToken":data.access_token}).find();
      if (old.password === data.oldPassword){
          //密码正确
          let newPw = await this.model('user').where({"accessToken":data.access_token}).update({"password":data.password})
          this.json({
              "code":0,
              "msg":"修改成功!"
          })
      } else {
          this.json({
              "code":0,
              "msg":"原密码错误!"
          })
      }
  }
  //重置密码
  async resetPwAction(){
      let data = this.post();
      let password = "e10adc3949ba59abbe56e057f20f883e";//默认"123456" md5加密
      let pw = await this.model('user').where({"id":data.id}).update({"password":password});
      this.json({
          "code":0,
          "msg":"重置成功"
      })
  }
};
