const request = require('request');


//获取guid
var getGUID = function () {
    return new Promise((resolve, reject)=>{
        var data = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/"><s:Body><UserCheck xmlns="http://tempuri.org/">' +
            '<YHID>2766BXL</YHID><YHMM>aeed9539ea3761e7627ea0348f721ef9fad6c4d73fc0e659562bb2360b3641bc</YHMM>' +
            '<MAC>94-86-E3-7A-62-B0-D7-2E-69-F9-0B-24-F7-1E-22-09</MAC><VERSION>机动车安全技术检验业务信息系统-客户端/3.1.0.22</VERSION></UserCheck></s:Body></s:Envelope>'
        request({
            url: 'https://172.168.1.4/xtglV2/User.svc',//请求路径
            method: 'POST',//请求方式
            headers: {
                //设置请求头
                'Content-type': 'text/xml;charset=utf-8',
                'SOAPAction':'http://tempuri.org/IUser/UserCheck'
            },
            rejectUnauthorized:false,
            body: data//post参数字符串
        }, function(error, response, body) {
            var parseString = require('xml2js').parseString;
            parseString(body, function (err, result) {
                var guid = result['s:Envelope']['s:Body'][0]['UserCheckResponse'][0]['UserCheckResult'][0]['a:Item'][0]['b:GUID'][0];
                resolve(guid)
            })
        });
    })
}

//代检车辆列表
var getList = function (guid,num){//num 1,3本地外地
    return new Promise((resolve, reject)=>{
        var data = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/"><s:Body><DJQD xmlns="http://tempuri.org/"><sGUID>' +
            guid +
            '</sGUID><MAC>94-86-E3-7A-62-B0-D7-2E-69-F9-0B-24-F7-1E-22-09</MAC><JYLB>' + num + '</JYLB><PXFS>1</PXFS></DJQD></s:Body></s:Envelope>'
        //<JYLB>1</JYLB>本地     <JYLB>3</JYLB>外地
        request({
            // url: 'https://172.168.1.5/ywxtV2/YCDL.svc',//请求路径
            url: 'https://172.168.1.5/ywxt/YCDL.svc',//请求路径
            method: 'POST',//请求方式
            headers: {
                //设置请求头
                'content-type': 'text/xml;charset=utf-8',
                'SOAPAction':'http://tempuri.org/IYCDL/DJQD'
            },
            rejectUnauthorized:false,
            body: data//post参数字符串
        }, function(error, response, body) {
            var parseString = require('xml2js').parseString;
            parseString(body, function (err, result) {
                // console.log(result['s:Envelope']['s:Body'][0]['DJQDResponse'][0]['DJQDResult'][0]['a:Items'][0]['b:string']);
                var list = result['s:Envelope']['s:Body'][0]['DJQDResponse'][0]['DJQDResult'][0]['a:Items'][0]['b:string'];
                // console.log(result['s:Envelope']['s:Body'][0]['DJQDResponse'][0]['DJQDResult']);
                resolve(list)
            })
        });
    });
}

//车辆详情
function getDetail(guid,HPHM,HPZL,num){//num 1,3本地外地
    return new Promise((resolve, reject)=>{
        var data = '<s:Envelope xmlns:s="http://schemas.xmlsoap.org/soap/envelope/"><s:Body><getVehInfo xmlns="http://tempuri.org/"><GUID>'
            +guid+'</GUID><HPHM>'+HPHM+'</HPHM><HPZL>'+HPZL+'</HPZL><JYLB>' + num + '</JYLB></getVehInfo></s:Body></s:Envelope>'
        //<JYLB>1</JYLB>本地     <JYLB>3</JYLB>外地
        request({
            // url: 'https://172.168.1.5/ywxtV2/YCDL.svc',//请求路径
            url: 'https://172.168.1.5/ywxt/YCDL.svc',//请求路径
            method: 'POST',//请求方式
            headers: {
                //设置请求头
                'content-type': 'text/xml',
                'SOAPAction':'http://tempuri.org/IYCDL/getVehInfo'
            },
            rejectUnauthorized:false,
            body: data//post参数字符串
        }, function(error, response, body) {
            var parseString = require('xml2js').parseString;
            parseString(body, function (err, result) {
                // console.log(result['s:Envelope']['s:Body'][0]['getVehInfoResponse'][0]['getVehInfoResult'][0]['a:Message']);
                var list = result['s:Envelope']['s:Body'][0]['getVehInfoResponse'][0]['getVehInfoResult'][0]['a:Item'][0];
                var detail = {
                    "车牌":list['b:HPHM'][0],
                    "初次登记":list['b:CCDJRQ'][0],
                    "有效期止":list['b:CCRQ'][0],
                    "车辆类型":list['b:CLLX'][0],
                    "车辆识别代号":list['b:CLSBDH'][0],
                    "检验情况":list['b:JYQKSM'][0],
                    "车辆品牌":list['b:CLPP1'][0],
                    "所有人":list['b:SYR'][0],
                    "行政区划":list['b:XZQH'][0],
                    "车辆型号":list['b:CLXH'][0],
                };
                resolve(detail)
            })
        });
    })
}

//Json排序 field排序字段 rev true 倒序 false顺序 primer parseInt 整型 String 字符串
//obj.sort(sortBy(filed,true/false,parseInt/String))
var sortBy = function (filed, rev, primer) {
    rev = (rev) ? -1 : 1;
    return function (a, b) {
        a = a[filed];
        b = b[filed];
        if (typeof (primer) != 'undefined') {
            a = primer(a);
            b = primer(b);
        }
        if (a < b) { return rev * -1; }
        if (a > b) { return rev * 1; }
        return 1;
    }
};

exports.getGUID = getGUID;
exports.getList = getList;
exports.getDetail = getDetail;
exports.sortBy = sortBy;
